;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include CodeComplete.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD

	mov		eax,hInst
	mov		hInstance,eax
	mov		eax,TRUE
	ret

DllEntry Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallDll proc uses ebx,hWin:DWORD,fOpt:DWORD

	mov		ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0	
	mov		lpHandles,eax
	;Get handle of unsorted popup listbox
	mov		eax,[eax].ADDINHANDLES.hLBU
	mov		hLB,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov		lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov		lpData,eax

	; Messages to hook into
	mov		eax,RAM_CLOSE or RAM_EDITOPEN or RAM_MDIACTIVATE
	mov		ecx,RAM_UNHOOK
	; EDX must be null before we return
	xor		edx,edx
	ret

InstallDll Endp

IsLineCoInvoke proc uses esi edi,npos:DWORD

	mov		esi,offset linebuff
	mov		edi,offset szCoInvoke
	dec		esi
	mov		ecx,npos
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	mov		al,[esi]
	cmp		al,VK_SPACE
	je		@b
	cmp		al,VK_TAB
	je		@b
	dec		esi
	dec		edi
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	inc		edi
	mov		al,[edi]
	mov		ah,[esi]
;	.if al>='a' && al<='z'
;		and		al,5Fh
;	.endif
;	.if ah>='a' && ah<='z'
;		and		ah,5Fh
;	.endif
	sub		ah,al
	je		@b
	.if !al && (ah==VK_SPACE || ah==VK_TAB)
		xor		eax,eax
	.endif
  @@:
	ret
  Ex:
	xor		eax,eax
	dec		eax
	ret

IsLineCoInvoke endp

FindHook proc uses ebx,hWin:HWND

	mov		ebx,offset hooks
	mov		eax,hWin
	.while eax!=[ebx].HOOKS.hWin && ebx<offset hooks+sizeof HOOKS*200
		add		ebx,sizeof HOOKS
	.endw
	.if eax==[ebx].HOOKS.hWin && ebx<offset hooks+sizeof HOOKS*200
		mov		eax,ebx
	.else
		xor		eax,eax
	.endif
	ret

FindHook endp

UnHook proc uses ebx,lpHook:DWORD

	mov		ebx,lpHook
	;Let the next in the chain unhook me (if any)
	push	RAM_UNHOOK
	push	[ebx].HOOKS.lpOldCallBack
	push	[ebx].HOOKS.lpCallBack
	push	AIM_UNHOOK
	push	[ebx].HOOKS.hWin
	mov		eax,lpProc
	call	[eax].ADDINPROCS.lpDllProc
	invoke GetWindowLong,[ebx].HOOKS.hWin,GWL_WNDPROC
	.if eax==[ebx].HOOKS.lpCallBack
		;Last in chain, just unhook
		invoke SetWindowLong,[ebx].HOOKS.hWin,GWL_WNDPROC,[ebx].HOOKS.lpOldCallBack
		mov		[ebx].HOOKS.hWin,0
	.endif
	ret

UnHook endp

MdiChildProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	pt:POINT

	invoke FindHook,hWin
	mov		ebx,eax
	.if uMsg==WM_NOTIFY
		push	ebx
		;Get pointer to RASELCHANGE structure
		mov		ebx,lParam
		;Check if it is SEL_TEXT notification
		.if [ebx].RASELCHANGE.seltyp==SEL_TEXT
			mov		eax,[ebx].RASELCHANGE.line
			.if eax!=nLine || [ebx].RASELCHANGE.fchanged
				mov		nLine,eax
				;Hide the listbox
				.if fLB
					invoke ShowWindow,hLB,SW_HIDE
					mov		fLB,FALSE
				.endif
				.if [ebx].RASELCHANGE.fchanged
					;Get the line text
					push	esi
					push	edi
					mov		esi,[ebx].RASELCHANGE.lpLine
					mov		ecx,[esi].CHARS.len
					lea		esi,[esi+sizeof CHARS]
					mov		edi,offset linebuff
					rep movsb
					;Zero terminate line
					mov		byte ptr [edi],0
					.if byte ptr [edi-1]==VK_RETURN
						;Dont want CR
						mov		byte ptr [edi-1],0
					.endif
					mov		eax,[ebx].RASELCHANGE.chrg.cpMin
					sub		eax,[ebx].RASELCHANGE.cpLine
					invoke IsLineCoInvoke,eax
					.if !eax
						invoke SendMessage,hLB,LB_RESETCONTENT,0,0
						;put some text into listbox
						push	esi
						mov		esi,offset szSomeText
						.while byte ptr [esi]
							invoke SendMessage,hLB,LB_ADDSTRING,0,esi
							invoke lstrlen,esi
							lea		esi,[esi+eax+1]
						.endw
						pop		esi
						;Set listbox position
						invoke GetCaretPos,addr pt
						invoke GetFocus
						mov		edx,eax
						invoke ClientToScreen,edx,addr pt
						add		pt.y,20
						invoke MoveWindow,hLB,pt.x,pt.y,200,150,FALSE
						;Show listbox
						invoke ShowWindow,hLB,SW_SHOWNA
						invoke SendMessage,hLB,LB_SETCURSEL,0,0
						mov		fLB,TRUE
					.endif
					pop		edi
					pop		esi
				.endif
			.endif
		.endif
		pop		ebx
	.elseif uMsg==WM_DESTROY
		invoke UnHook,ebx
		mov		[ebx].HOOKS.hWin,0
	.endif
	invoke CallWindowProc,[ebx].HOOKS.lpOldCallBack,hWin,uMsg,wParam,lParam
	ret

MdiChildProc endp

EditProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	buffer[64]:BYTE

	invoke FindHook,hWin
	mov		ebx,eax
	.if uMsg==WM_KEYDOWN
		mov		edx,wParam
		mov		eax,lParam
		shr		eax,16
		and		eax,3FFh
		.if edx==28h && (eax==150h || eax==50h)
			;Down
			invoke IsWindowVisible,hLB
			.if eax
				invoke SendMessage,hLB,LB_SETCURSEL,1,0
				invoke SetFocus,hLB
				xor		eax,eax
				jmp		Ex
			.endif
		.endif
	.elseif uMsg==WM_CHAR
		mov		eax,wParam
		.if eax==VK_TAB && fLB
			invoke SendMessage,hLB,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				mov		edx,eax
				invoke SendMessage,hLB,LB_GETTEXT,edx,addr buffer
				invoke GetParent,hWin
				mov		edx,eax
				invoke SendMessage,edx,EM_REPLACESEL,TRUE,addr buffer
			.endif
			xor		eax,eax
			jmp		Ex
		.else
			.if eax==VK_ESCAPE && fLB
				;Hide listbox
				invoke ShowWindow,hLB,SW_HIDE
				xor		eax,eax
				jmp		Ex
			.endif
			invoke CallWindowProc,[ebx].HOOKS.lpOldCallBack,hWin,uMsg,wParam,lParam
			push	eax
			.if fLB
				;Show listbox
				invoke ShowWindow,hLB,SW_SHOWNA
			.endif
			pop		eax
			jmp		Ex
		.endif
	.elseif uMsg==WM_DESTROY
		invoke UnHook,ebx
		mov		[ebx].HOOKS.hWin,0
	.endif
	invoke CallWindowProc,[ebx].HOOKS.lpOldCallBack,hWin,uMsg,wParam,lParam
  Ex:
	ret

EditProc endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
DllProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov		eax,uMsg
	.if eax==AIM_EDITOPEN
		;Always return false
		;hWin		handle of mdi child window
		;wParam		handle of RAEdit
		;Check if it is a code edit mdi child
		invoke GetWindowLong,hWin,0
		.if eax==ID_EDIT
			;Get a free hook
			invoke FindHook,0
			.if eax
				push	ebx
				mov		ebx,eax
				;Subclass the mdi child
				mov		eax,hWin
				mov		[ebx].HOOKS.hWin,eax
				invoke SetWindowLong,eax,GWL_WNDPROC,offset MdiChildProc
				mov		[ebx].HOOKS.lpOldCallBack,eax
				mov		[ebx].HOOKS.lpCallBack,offset MdiChildProc
				;Get a free hook
				invoke FindHook,0
				.if eax
					mov		ebx,eax
					;Subclass the RAEdit child windows
					invoke GetWindowLong,hWin,GWL_USERDATA
					invoke GetWindowLong,eax,0
					mov		edx,[eax].EDIT.edta.hwnd
					mov		[ebx].HOOKS.hWin,edx
					invoke SetWindowLong,edx,GWL_WNDPROC,offset EditProc
					mov		[ebx].HOOKS.lpOldCallBack,eax
					mov		[ebx].HOOKS.lpCallBack,offset EditProc
					;Get a free hook
					invoke FindHook,0
					.if eax
						mov		ebx,eax
						invoke GetWindowLong,hWin,GWL_USERDATA
						invoke GetWindowLong,eax,0
						mov		edx,[eax].EDIT.edtb.hwnd
						mov		[ebx].HOOKS.hWin,edx
						invoke SetWindowLong,edx,GWL_WNDPROC,offset EditProc
						mov		[ebx].HOOKS.lpOldCallBack,eax
						mov		[ebx].HOOKS.lpCallBack,offset EditProc
					.endif
				.endif
				pop		ebx
			.endif
		.endif
	.elseif eax==AIM_MDIACTIVATE
		;A new edit window is selected, reset flags and hide listbox
		xor		eax,eax
		dec		eax
		mov		nLine,eax
		mov		nPos,eax
		.if fLB
			invoke ShowWindow,hLB,SW_HIDE
			mov		fLB,FALSE
		.endif
	.elseif eax==AIM_CLOSE
		;Undo all subclassing
		push	ebx
		mov		ebx,offset hooks
		.while ebx<offset hooks+sizeof HOOKS*200
			.if [ebx].HOOKS.hWin
				invoke UnHook,ebx
			.endif
			add		ebx,sizeof HOOKS
		.endw
		pop		ebx
	.elseif eax==AIM_UNHOOK
		invoke FindHook,hWin
		.if eax
			mov		edx,wParam
			.if edx==[eax].HOOKS.lpOldCallBack
				;Remove the hook from the chain
				mov		edx,lParam
				mov		[eax].HOOKS.lpOldCallBack,edx
				mov		eax,TRUE
				jmp		Ex
			.endif
		.endif
	.endif
	xor eax,eax
  Ex:
	ret

DllProc Endp

;#########################################################################

End DllEntry

