
;#########################################################################
;		Include files

	include windows.inc
	include kernel32.inc
	include user32.inc
;	include Comctl32.inc
;	include shell32.inc
;	include ComDlg32.inc
	include Gdi32.inc

;#########################################################################
;		Libraries

	includelib kernel32.lib
	includelib user32.lib
;	includelib Comctl32.lib
;	includelib shell32.lib
;	includelib ComDlg32.lib
	includelib Gdi32.lib

;#########################################################################
;		RadASM Add In Include

	include \RadASM\Masm\Inc\radasm.inc

;#########################################################################
;		VKim's Debug

;	include masm32.inc
;	include \RadASM\masm\inc\debug.inc
;	includelib \RadASM\masm\lib\debug.lib

	DBGWIN_DEBUG_ON = 1		; include debug info into the program
	DBGWIN_EXT_INFO = 0		; include extra debug info into the program

;#########################################################################
;		Prototypes

	DLLProc					PROTO :DWORD, :DWORD, :DWORD, :DWORD
	InstallDLL				PROTO :DWORD, :DWORD
	
	TextOutput				PROTO :DWORD
	clrOutput				PROTO 
	HexOutput				PROTO :DWORD

RASELCHANGE struct
	nmhdr		NMHDR <?>
	chrg		CHARRANGE <?>				;Current selection
	seltyp		dw ?						;SEL_TEXT or SEL_OBJECT
	line		dd ?						;Line number
	cpLine		dd ?						;Character position of first character
	lpLine		dd ?						;Pointer to line
	nlines		dd ?						;Total number of lines
	nhidden		dd ?						;Total number of hidden lines
	fchanged	dd ?						;TRUE if changed since last
	npage		dd ?						;Page number
	nWordGroup	dd ?						;Hilite word group
RASELCHANGE ends

CHARS struct
	len			dd ?						;String len
	max			dd ?						;Max size
	state		dd ?						;Line state
	bmid		dd ?						;Bookmark ID
CHARS ends

ID_EDIT 					equ 65501
REM_BASE					equ WM_USER+1000
REM_SUBCLASS				equ REM_BASE+29		;wParam=0, lParam=lpWndProc

.const

szCoInvoke					db 'CoInvoke',0

szSomeText					db 'item0',0
							db 'item1',0
							db 'item2',0
							db 'item3',0
							db 'item4',0,0

HOOKS struct
	hWin			HWND ?
	lpCallBack		DWORD ?
	lpOldCallBack	DWORD ?	
HOOKS ends

RAEDT struct
	hwnd		dd ?		;Handle of edit a or b
	hvscroll	dd ?		;Handle of scroll bar
	cpxmax		dd ?		;Last cursor pos x
	cpy			dd ?		;Scroll position
	cp			dd ?		;Character position
	rc			RECT <?>	;Edit a or b rect
	topyp		dd ?		;First visible lines Y position
	topln		dd ?		;First visible lines linenumber
	topcp		dd ?		;First visible lines character position
RAEDT ends

EDIT struct
	hwnd		dd ?		;Handle of main window
	fstyle		dd ?		;Window style
	ID			dd ?		;Window ID
	hpar		dd ?		;Handle of parent window
	edta		RAEDT <>
	edtb		RAEDT <>
	;There is a lot more, but we don't need it here
EDIT ends

.data


.data?

	hInstance			dd ?	;Dll's module handle
	lpHandles			dd ?	;Pointer to handles struct
	lpProc				dd ?	;Pointer to proc struct
	lpData				dd ?	;Pointer to data struct
	hOut				dd ?	;Handle of output window
	fLB					dd ?
	hLB					dd ?
	nLine				dd ?
	nPos				dd ?
	linebuff			db 16384 dup(?)
	hooks				HOOKS 300 dup(<?>)

.code

;#########################################################################
;		Output Window procs

TextOutput proc lpszStr

   pushad
   
   push  lpszStr
   mov   eax,lpProc
   call  [eax].ADDINPROCS.lpTextOut
   
   popad	
   ret

TextOutput endp

;#########################################################################

clrOutput proc

   pushad
   
   mov   eax,lpProc
   call  [eax].ADDINPROCS.lpClearOut
   
   popad	
   ret

clrOutput endp

;#########################################################################

HexOutput proc val:DWORD
	
	pushad
	
	push  val
	mov   eax,lpProc
	call  [eax].ADDINPROCS.lpHexOut
	
	popad
	ret
	
HexOutput endp
